<?php
/***************************************************************************
 *                                                                          *
 *   Author:	Moses King'ori												*
 *   Email:		moseskariuki2119@gmail.com                                  *
 *   Provider:	iPay Limited 												*
 *                                                                          *
 ****************************************************************************
 * PLEASE READ THE FULL TEXT  OF THE SOFTWARE  LICENSE   AGREEMENT  IN  THE *
 * "copyright.txt" FILE PROVIDED WITH THIS DISTRIBUTION PACKAGE.            *
 ****************************************************************************/

if (!defined('BOOTSTRAP')) {die('Access denied');}

if (defined('PAYMENT_NOTIFICATION')) {

	$payment_id = db_get_field("SELECT payment_id FROM ?:orders WHERE order_id = ?i", $_REQUEST['id']);
	$processor_data = fn_get_payment_method_data($payment_id);

	$request = 'vendor=' . $processor_data['processor_params']['ipay_vendor_id'];
	$request .= '&id=' . $_REQUEST['id'];
	$request .= '&ivm=' . $_REQUEST['ivm'];
	$request .= '&qwh=' . $_REQUEST['qwh'];
	$request .= '&afd=' . $_REQUEST['afd'];
	$request .= '&poi=' . $_REQUEST['poi'];
	$request .= '&uyt=' . $_REQUEST['uyt'];
	$request .= '&ifd=' . $_REQUEST['ifd'];

	$ipnbase = '';

	switch ($processor_data['processor_params']['ipay_country']) {
	case 'KE':
		$ipnbase = 'https://www.ipayafrica.com/ipn';
		break;
	case 'TZ':
		$ipnbase = 'https://payments.elipa.co.tz/v3/tz/ipn';
		break;
	case 'UG':
		$ipnbase = 'https://payments.elipa.co.ug/v3/ug/ipn';
		break;
	case 'TG':
		$ipnbase = 'https://payments.elipa.tg/ipn';
		break;
	}

	$ipnurl = $ipnbase . "?" . $request;

	$fp = fopen($ipnurl, "rb");
	$response = stream_get_contents($fp, -1, -1);
	fclose($fp);

	if ($processor_data['processor_params']['ipay_mode'] == 'test') {
		$response = 'aei7p7yrx4ae34';
	}

	$pp_response = array();
	$pp_response['transaction_id'] = $_REQUEST['txncd'];

	switch ($response) {
	case 'aei7p7yrx4ae34':
	case 'eq3i7p5yt7645e':
		$pp_response['order_status'] = 'P';
		$pp_response['reason_text'] = "Transaction successful - iPay";
		break;
	case 'bdi6p2yy76etrs':
		$pp_response['order_status'] = 'F';
		$pp_response['reason_text'] = "Transaction pending - iPay";
		break;
	case 'cr5i3pgy9867e1':
		$pp_response['order_status'] = 'F';
		$pp_response['reason_text'] = "Transaction already used - iPay";
		break;
	case 'dtfi4p7yty45wq':
		$pp_response['order_status'] = 'F';
		$pp_response['reason_text'] = "Transaction paid less - iPay";
		break;
	case 'fe2707etr5s4wq':
		$pp_response['order_status'] = 'F';
		$pp_response['reason_text'] = "Transaction failed - iPay";
		break;
	default:
		$pp_response['order_status'] = 'F';
		$pp_response['reason_text'] = "Unknown transaction response - iPay";
		break;
	}

	fn_finish_payment($_REQUEST['id'], $pp_response, true);
	fn_order_placement_routines('route', $_REQUEST['id'], true);

} else {

	$live = ($processor_data['processor_params']['ipay_mode'] == 'test') ? 0 : 1;
	$autopay = ($processor_data['processor_params']['ipay_autopay'] == 'no') ? 0 : 1;

	$mer = $processor_data['processor_params']['ipay_merchant_name'];
	$tel = $order_info['phone'];

	$tel = str_replace("-", "", $tel);
	$tel = str_replace(array(' ', '<', '>', '&', '{', '}', '*', "+", '!', '@', '#', "$", '%', '^', '&'), "", $tel);
	$eml = $order_info['email'];
	$vid = $processor_data['processor_params']['ipay_vendor_id'];
	$oid = $order_id;
	$inv = $oid;
	$p1 = '';
	$p2 = '';
	$p3 = '';
	$p4 = '';

	$curr = '';
	$baseurl = '';

	switch ($processor_data['processor_params']['ipay_country']) {
	case 'KE':
		$curr = 'KES';
		$baseurl = 'https://payments.ipayafrica.com/v3/ke';
		break;
	case 'TZ':
		$curr = 'TZS';
		$baseurl = 'https://payments.elipa.co.tz/v3/tz';
		break;
	case 'UG':
		$curr = 'UGX';
		$baseurl = 'https://payments.elipa.co.ug/v3/ug';
		break;
	case 'TG':
		$curr = '‎XOF';
		$baseurl = 'https://payments.elipa.tg/v1/v3/index.php/togo';
		break;
	}

	if ($processor_data['processor_params']['ipay_currency'] == "USD") {
		$curr = 'USD';
	}

	$ttl = $order_info['total'];

	$crl = '0';
	$cst = '1';
	$cbk = fn_url("payment_notification.finish?payment=ipay&refno={$order_id}", AREA, 'current');

	$hsh = $processor_data['processor_params']['ipay_secret_key'];

	$datastring = $live . $oid . $inv . $ttl . $tel . $eml . $vid . $curr . $p1 . $p2 . $p3 . $p4 . $cbk . $cst . $crl;

	$hash = hash_hmac('sha1', $datastring, $hsh);

	$cbk = urlencode($cbk);

	$url = $baseurl . "?live=" . $live . "&oid=" . $oid . "&inv=" . $inv . "&ttl=" . $ttl . "&tel=" . $tel . "&eml=" . $eml . "&vid=" . $vid . "&curr=" . $curr . "&p1=" . $p1 . "&p2=" . $p2 . "&p3=" . $p3 . "&p4=" . $p4 . "&cbk=" . $cbk . "&cst=" . $cst . "&crl=" . $crl . "&hsh=" . $hash . "&autopay=" . $autopay;

	fn_create_payment_form($url, array(), 'iPay');
	exit();
}
